SUBROUTINE INIT_PY(KULOUT,PTSTEP,LDWARM,CMICRO,KSPLITR,CCSEDIM,LDCRIAUTI,&
                   PCRIAUTI,PT0CRIAUTI,PCRIAUTC, PTSTEP_TS, CCSNOWRIMING, PMRSTEP, KMAXITER, &
                   LDFEEDBACKT, LDEVLIMIT, LDNULLWETG, LDWETGPOST, LDNULLWETH, LDWETHPOST, &
                   PFRACM90, LDCONVHG, CCSUBG_RC_RR_ACCR, CCSUBG_RR_EVAP, CCSUBG_PR_PDF, &
                   LDCRFLIMIT, CCFRAC_ICE_ADJUST, PSPLIT_MAXCFL,&
                   CCFRAC_ICE_SHALLOW_MF, LDSEDIM_AFTER)

USE MODD_RAIN_ICE_DESCR
USE MODD_RAIN_ICE_PARAM
USE MODD_PARAM_ICE
USE MODD_PARAM_C1R3

USE MODD_REF
USE MODD_NEB
USE MODI_INI_RAIN_ICE

USE MODD_LUNIT_n, ONLY : TLUOUT

IMPLICIT NONE
! -----------------------------------------------------------------------
!     DUMMY INTEGER SCALARS
INTEGER, INTENT (IN) :: KULOUT
REAL, INTENT (IN) :: PTSTEP
LOGICAL(KIND=1), INTENT (IN) :: LDWARM
CHARACTER(4), INTENT (IN) :: CMICRO 
CHARACTER(4), INTENT (IN) :: CCSEDIM
INTEGER, INTENT (OUT) :: KSPLITR
LOGICAL(KIND=1), INTENT (IN) :: LDCRIAUTI
REAL, INTENT (IN) :: PCRIAUTI
REAL, INTENT (IN) :: PT0CRIAUTI
REAL, INTENT (IN) :: PCRIAUTC
REAL, INTENT (IN) :: PTSTEP_TS
CHARACTER(4), INTENT (IN) :: CCSNOWRIMING
REAL, INTENT (IN) :: PMRSTEP
INTEGER, INTENT (IN) :: KMAXITER
LOGICAL(KIND=1), INTENT (IN) :: LDFEEDBACKT
LOGICAL(KIND=1), INTENT (IN) :: LDEVLIMIT
LOGICAL(KIND=1), INTENT (IN) :: LDNULLWETG
LOGICAL(KIND=1), INTENT (IN) :: LDWETGPOST
LOGICAL(KIND=1), INTENT (IN) :: LDNULLWETH
LOGICAL(KIND=1), INTENT (IN) :: LDWETHPOST
REAL, INTENT (IN) :: PFRACM90
LOGICAL(KIND=1), INTENT (IN) :: LDCONVHG
CHARACTER(LEN=80), INTENT(IN) :: CCSUBG_RC_RR_ACCR
CHARACTER(LEN=80), INTENT(IN) :: CCSUBG_RR_EVAP
CHARACTER(LEN=80), INTENT(IN) :: CCSUBG_PR_PDF
LOGICAL(KIND=1), INTENT (IN) :: LDCRFLIMIT
CHARACTER(LEN=1), INTENT(IN) :: CCFRAC_ICE_ADJUST
REAL, INTENT (IN) :: PSPLIT_MAXCFL
CHARACTER(LEN=1), INTENT(IN) :: CCFRAC_ICE_SHALLOW_MF
LOGICAL(KIND=1), INTENT (IN) :: LDSEDIM_AFTER
!-----------------------------------------------------------------------
!    LOCAL VARIABLES
REAL :: ZCRI0, ZTCRI0    
! -----------------------------------------------------------------------

IF (.NOT.ASSOCIATED(TLUOUT)) ALLOCATE(TLUOUT)
TLUOUT%NLU=2

CALL INI_CST


!        1. Set implicit default values for MODD_PARAM_ICE
LWARM=LDWARM
CPRISTINE_ICE='PLAT'
CPRISTINE_ICE_C1R3='PLAT'
CHEVRIMED_ICE_C1R3='GRAU'
CSEDIM=CCSEDIM
CSUBG_RC_RR_ACCR=CCSUBG_RC_RR_ACCR
CSUBG_RR_EVAP=CCSUBG_RR_EVAP
CSUBG_PR_PDF=CCSUBG_PR_PDF
LFEEDBACKT=LDFEEDBACKT ! When .TRUE. feed back on temperature is taken into account
LEVLIMIT=LDEVLIMIT   ! When .TRUE. water vapour pressure is limited by saturation
LNULLWETG=LDNULLWETG  ! When .TRUE. graupel wet growth is activated with null rate (to allow water shedding)
LWETGPOST=LDWETGPOST  ! When .TRUE. graupel wet growth is activated with positive temperature (to allow water shedding)
LNULLWETH=LDNULLWETH  ! Same as LNULLWETG but for hail
LWETHPOST=LDWETHPOST  ! Same as LWETGPOST but for hail
CSNOWRIMING=CCSNOWRIMING ! OLD or M90 for Murakami 1990 formulation
XFRACM90=PFRACM90 ! Fraction used for the Murakami 1990 formulation
NMAXITER=KMAXITER ! Maximum number of iterations for mixing ratio  or time splitting
XMRSTEP=PMRSTEP ! maximum mixing ratio step for mixing ratio splitting
LCONVHG=LDCONVHG ! TRUE to allow the conversion from hail to graupel
LCRFLIMIT=LDCRFLIMIT !True to limit rain contact freezing to possible heat exchange
CFRAC_ICE_ADJUST=CCFRAC_ICE_ADJUST !Choice of solid/liquid partition in adjustements
CFRAC_ICE_SHALLOW_MF=CCFRAC_ICE_SHALLOW_MF !Choice of solid/liquid partition in shallow_mf
XSPLIT_MAXCFL=PSPLIT_MAXCFL
LSEDIM_AFTER=LDSEDIM_AFTER ! sedimentation done before or after microphysics
!
XTSTEP_TS=PTSTEP_TS ! Approximative time step for time-splitting (0 for no time-splitting)
!
!        2. Set implicit default values for MODD_RAIN_ICE_DESCR 
!                     et MODD_RAIN_ICE_PARAM
IF(.NOT. ALLOCATED(XTHVREFZ)) THEN
  ALLOCATE(XTHVREFZ(2))
  XTHVREFZ=300.
ENDIF
!
XTMAXMIX    = 273.16
XTMINMIX    = 253.16
!
CALL INI_RAIN_ICE (KULOUT, PTSTEP, 20.,KSPLITR,CMICRO)
!update values from namparar
IF (LDCRIAUTI) THEN

  XCRIAUTI=PCRIAUTI
  XCRIAUTC=PCRIAUTC
  XT0CRIAUTI=PT0CRIAUTI
  !second point to determine 10**(aT+b) law
  ZTCRI0=-40.0
  ZCRI0=1.25E-6
  
  XBCRIAUTI=-( LOG10(XCRIAUTI) - LOG10(ZCRI0)*PT0CRIAUTI/ZTCRI0 )&
                   *ZTCRI0/(XT0CRIAUTI-ZTCRI0)
  XACRIAUTI=(LOG10(ZCRI0)-XBCRIAUTI)/ZTCRI0
  
ENDIF
! -----------------------------------------------------------------------

END SUBROUTINE INIT_PY

